REPORT scheme_report( r_scheme, rep_type, screen_num )

DEFINE
	r_scheme			RECORD LIKE pe_sch.*,
	rep_type			CHAR( 1 ),
	screen_num			SMALLINT,

	temp_scrn_desc RECORD
		scrn_code		LIKE pe_ssel.psl_code,
		scrn_desc		LIKE pe_ssel.psl_desc,
		scrn_print		CHAR( 1 )
	END RECORD,

	i				SMALLINT,
	l				SMALLINT,
	sec_str				CHAR( 100 ),
	sec_print 			SMALLINT,

	client_crown_agents_bank	SMALLINT,

	sch_label			CHAR( 15 ),
	company_string			LIKE pe_sysp.pp_name,
	time_string			CHAR( 20 ),
	user_string			CHAR( 18 ),
	r_trailer			CHAR( 150 )


	ORDER EXTERNAL BY r_scheme.psc_scheme, screen_num

	FORMAT

	FIRST PAGE HEADER
		# print first and second heading lines
		CALL get_first_heading2()
			RETURNING company_string, user_string, time_string

		PRINT company_string, user_string, time_string

		LET r_trailer = page_trailer( "PY" )
		PRINT r_trailer

		LET sch_label = get_rep_label( "S" )
		PRINT sch_label

		LET sec_str = mem_sec_fail_str( 2 )
		PRINT sec_str

		PRINT rep_type

		LET client_crown_agents_bank = client_specific( "CROWN AGENTS BANK" )

		PRINT client_crown_agents_bank

		# get user and scheme security ratings
		SELECT user_security
		INTO p_security
		FROM gn_user
		WHERE gn_user.user_id = p_user

	BEFORE GROUP OF r_scheme.psc_scheme
		LET sec_print = sch_sec_chk( r_scheme.psc_scheme )

		PRINT r_scheme.*, sec_print

	BEFORE GROUP OF screen_num
		LET l = screen_num
		LET temp_scrn_desc.* = p_scrn_desc[ l ].*
		PRINT temp_scrn_desc.*

	ON EVERY ROW
		IF sec_print = TRUE THEN
{*************************SCHEME DETAILS SCREEN*****************************}
			IF p_scrn_desc[ l ].scrn_code = "ADDR" THEN
				START REPORT scheme_details
				OUTPUT TO REPORT scheme_details( r_scheme )
				FINISH REPORT scheme_details
			END IF

{*************************SCHEME'S BANK DETAILS SCREEN**********************}
			IF p_scrn_desc[ l ].scrn_code = "BANK" THEN
				START REPORT scheme_bank_details
				OUTPUT TO REPORT scheme_bank_details( r_scheme )
				FINISH REPORT scheme_bank_details
			END IF

{*************************SCHEME'S RTI DETAILS SCREEN**********************}
			IF p_scrn_desc[ l ].scrn_code = "RTI" THEN
				START REPORT scheme_rti_details
				OUTPUT TO REPORT scheme_rti_details( r_scheme )
				FINISH REPORT scheme_rti_details
			END IF
		END IF

END REPORT { scheme_report }


REPORT scheme_details( r_scheme )

DEFINE
	r_scheme			RECORD LIKE pe_sch.*,
#	i				SMALLINT,

	r_saddr				RECORD LIKE pe_saddr.*,
	contact_pref_desc		STRING,

	r_tax RECORD
		pys_taxname		LIKE py_sch.pys_taxname,
		pys_dist		LIKE py_sch.pys_dist,
		pys_ref			LIKE py_sch.pys_ref,
		pys_payslip_mess	LIKE py_sch.pys_payslip_mess,
		pys_payslip_tol		LIKE py_sch.pys_payslip_tol,
		pys_pay_adv		LIKE py_sch.pys_pay_adv,
		pys_netpay_tol		LIKE py_sch.pys_netpay_tol,
		pys_date_ceased		LIKE py_sch.pys_date_ceased,
		pys_annual_rate_curr	LIKE py_sch.pys_annual_rate_curr,
		pys_funded_curr		LIKE py_sch.pys_funded_curr,
		pys_exchange_rate_type	LIKE py_sch.pys_exchange_rate_type,
		pys_fixed_rate		LIKE py_sch.pys_fixed_rate,
		pys_fundman_code	LIKE py_sch.pys_fundman_code,
		pys_client_ac_number	LIKE py_sch.pys_client_ac_number,
		pys_calc_arrears	LIKE py_sch.pys_calc_arrears,
		pys_payroll_date_opt	LIKE py_sch.pys_payroll_date_opt,
		pys_payroll_date_no	LIKE py_sch.pys_payroll_date_no
	END RECORD,

	annual_rate_curr_desc		LIKE pe_currency.pcu_desc,
	funded_curr_desc		LIKE pe_currency.pcu_desc,
	r_fundman_desc			LIKE pe_codem.pcdm_desc,
	r_exchange_rate_type_desc	CHAR( 20 ),

	r_show_fixed			SMALLINT,
	r_show_fundman			SMALLINT,
	r_show_payroll_no		SMALLINT,

	payroll_date_desc		CHAR( 35 )


	FORMAT

	ON EVERY ROW
		SELECT pe_saddr.*
		INTO r_saddr.*
		FROM pe_saddr
		WHERE pe_saddr.psa_scheme = r_scheme.psc_scheme
		AND pe_saddr.psa_addr_code = "SCHEME"

		LET contact_pref_desc = static_convert_code_to_word( "psa_contact_pref", r_saddr.psa_contact_pref )

		PRINT r_saddr.*, contact_pref_desc

		SELECT pys_taxname, pys_dist, pys_ref, pys_payslip_mess, pys_payslip_tol, pys_pay_adv, pys_netpay_tol, pys_date_ceased, pys_annual_rate_curr, pys_funded_curr,
			pys_exchange_rate_type, pys_fixed_rate, pys_fundman_code, pys_client_ac_number, pys_calc_arrears, pys_payroll_date_opt, pys_payroll_date_no
		INTO r_tax.*
		FROM py_sch
		WHERE py_sch.pys_scheme = r_scheme.psc_scheme

		LET annual_rate_curr_desc = static_convert_code_to_word( "psc_base", r_tax.pys_annual_rate_curr )
		LET funded_curr_desc = static_convert_code_to_word( "psc_base", r_tax.pys_funded_curr )
		LET r_fundman_desc = code_chk( "", "M", "", r_tax.pys_fundman_code )
		LET r_exchange_rate_type_desc = static_convert_code_to_word( "pys_exchange_rate_type", r_tax.pys_exchange_rate_type )

		LET r_show_fixed = FALSE
		LET r_show_fundman = FALSE
		LET r_show_payroll_no = FALSE

		IF r_tax.pys_exchange_rate_type = "FIXED" THEN
			LET r_show_fixed = TRUE
		END IF

		IF r_tax.pys_exchange_rate_type = "EXCHANGE" THEN
			LET r_show_fundman = TRUE
		END IF

		LET payroll_date_desc = static_convert_code_to_word( "pys_payroll_date_opt", r_tax.pys_payroll_date_opt )

		IF r_tax.pys_payroll_date_opt = "F"
		OR r_tax.pys_payroll_date_opt = "L" THEN
			LET r_show_payroll_no = TRUE
		END IF

		PRINT r_tax.*, annual_rate_curr_desc, funded_curr_desc, r_exchange_rate_type_desc, r_fundman_desc, r_show_fixed, r_show_fundman, payroll_date_desc, r_show_payroll_no

		# FOR i = 1 TO 0
		# 	PRINT i
		# END FOR

END REPORT { scheme_details }


REPORT scheme_bank_details( r_scheme )

DEFINE
	r_scheme			RECORD LIKE pe_sch.*,
#	i				SMALLINT,

	r_bank RECORD
		pys_type		LIKE py_sch.pys_type,
		pys_bank_name		LIKE py_sch.pys_bank_name,
		pys_bank_addr1		LIKE py_sch.pys_bank_addr1,
		pys_bank_addr2		LIKE py_sch.pys_bank_addr2,
		pys_bank_addr3		LIKE py_sch.pys_bank_addr3,
		pys_bank_addr4		LIKE py_sch.pys_bank_addr4,
		pys_bank_postcode	LIKE py_sch.pys_bank_postcode,
		pys_bank_country	LIKE py_sch.pys_bank_country,
		pys_bank_ac_name	LIKE py_sch.pys_bank_ac_name,
		pys_bank_ac_no		LIKE py_sch.pys_bank_ac_no,
		pys_bank_sortcode	LIKE py_sch.pys_bank_sortcode,
		pys_curr_acc_number	LIKE py_sch.pys_curr_acc_number,
		pys_bs_roll_no		LIKE py_sch.pys_bs_roll_no,
		pys_bank_mess		LIKE py_sch.pys_bank_mess,
		pys_bony_company_id	LIKE py_sch.pys_bony_company_id
	END RECORD,

	country_desc			LIKE pe_codem.pcdm_desc,
	type_desc			CHAR( 40 ),
	bony_company_id_desc		CHAR( 20 )


	FORMAT

	ON EVERY ROW
		SELECT pys_type, pys_bank_name, pys_bank_addr1,
			pys_bank_addr2, pys_bank_addr3,
			pys_bank_addr4, pys_bank_postcode,
			pys_bank_country,
			pys_bank_ac_name, pys_bank_ac_no,
			pys_bank_sortcode, pys_curr_acc_number,
			pys_bs_roll_no, pys_bank_mess, pys_bony_company_id
		INTO r_bank.*
		FROM py_sch
		WHERE py_sch.pys_scheme = r_scheme.psc_scheme

		IF r_bank.pys_type IS NULL THEN
			LET r_bank.pys_type = "BANK"
		END IF

		LET country_desc = static_convert_code_to_word( "pcdm_code_Q", r_bank.pys_bank_country )
		LET type_desc = static_convert_code_to_word( "pys_type", r_bank.pys_type )
		LET bony_company_id_desc = static_convert_code_to_word( "pys_bony_company_id", r_bank.pys_bony_company_id )

		PRINT country_desc, type_desc, bony_company_id_desc, r_bank.*

		# FOR i = 1 TO 0
		# 	PRINT i
		# END FOR

END REPORT { scheme_bank_details }


REPORT scheme_rti_details( r_scheme )

DEFINE
	r_scheme			RECORD LIKE pe_sch.*,
#	i				SMALLINT,

	r_rti RECORD
		pys_sender		LIKE py_sch.pys_sender,
		pys_accounts_office_ref	LIKE py_sch.pys_accounts_office_ref,
		pys_gateway_id		LIKE py_sch.pys_gateway_id,
		pys_email		LIKE py_sch.pys_email
	END RECORD


	FORMAT

	ON EVERY ROW
		SELECT pys_sender, pys_accounts_office_ref, pys_gateway_id, pys_email
		INTO r_rti.*
		FROM py_sch
		WHERE py_sch.pys_scheme = r_scheme.psc_scheme

		PRINT r_rti.*

		# FOR i = 1 TO 0
		# 	PRINT i
		# END FOR

END REPORT { scheme_rti_details }

